package JavaCode;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;


/*
SLIDER: Local Short Reads DNA Sequence Alignment
Beta Release; Ver 0.1, 22th Mar. 2008
By: Nawar Malhis
Canada's Michael Smith Genome Sciences Centre
*/

public class CreateDB {

	static ReferenceSequences rs;
	
	public static void main(String[] args) throws Exception {
		Parameters.resetTime(); 
		if (args.length < 1) {
			return;
		}
		Parameters.read(args[0]);
		String[]   files = new String[Parameters.SEQ_VAR.length];
		int[] refSeqSize = new int[Parameters.SEQ_VAR.length];
		int ux = 0;
		// Oligo.nou = 2;
		Oligo.numberOfBACs = -1;
		ReferenceSequences.display = false;
		ReferenceSequences.ux = ux;
		rs = new ReferenceSequences();
		rs.fillCode();
		
		for(int i = 0; i < Parameters.SEQ_VAR.length; i++) {
			files[i] = Parameters.ch_name1 + Parameters.SEQ_VAR[i] + Parameters.ch_name2;
		}
		//* 
		refSeqSize = new int[files.length];
		rs.processReference(files, refSeqSize);
		saveRefSeqSize(files, refSeqSize);
		//*/
		// getRefSeqSize(Parameters.pathDB + Parameters.DATABASE, files, refSeqSize);
		//*
		rs.sequencability0(Parameters.pathDB + Parameters.DATABASE, files, refSeqSize);
		System.gc();
		rs.sequencability(Parameters.pathDB + Parameters.DATABASE, files, refSeqSize, 27);
		System.gc();
		rs.sequencability(Parameters.pathDB + Parameters.DATABASE, files, refSeqSize, 32);
		System.gc();
		rs.sequencability(Parameters.pathDB + Parameters.DATABASE, files, refSeqSize, 36);
		//*/
		System.err.print("\nTotal Execution time is: ");
		Parameters.printTime(Parameters.numberOfTimePoints - 1);
		System.err.println();
	}	
	static void getRefSeqSize(String dbfile, String[] fls, int[] refSeqSize) throws Exception {
		String line;
		StringTokenizer tokens;
		rs.refSeqSize = new int[refSeqSize.length];
		// System.err.println(dbfile + "refSeqSizes");
		BufferedReader reader = new BufferedReader(new FileReader(dbfile + "refSeqSizes"));
		for (int i = 0; i < refSeqSize.length; i++) {
			// System.err.print(i + "\tSize:\t");
			line           = reader.readLine();
			tokens         = new StringTokenizer(line);	
			rs.refSeqSize[i] = refSeqSize[i]      = new Integer(tokens.nextToken());
			// System.err.println(refSeqSize[i]);
		}
	}
	
	static void saveRefSeqSize(String[] fls, int[] refSeqSize) throws Exception {
		BufferedWriter writer = new BufferedWriter(new FileWriter(Parameters.pathDB + Parameters.DATABASE + "/refSeqSizes"));
		for (int i = 0; i < fls.length; i++) {
			writer.write("" + (refSeqSize[i]-1) + "\n");
		}
    	writer.close();	
	}

}
