package JavaCode;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.StringTokenizer;

public class SNPsPrediction {
	static ReferenceSequences rs;
	
	static       String[] files;
	static       int[][]  resultCount;
	
	public static void main(String[] args) throws Exception {
		Parameters.resetTime();
		if (args.length < 1) {
			return;
		}
		if (args.length >= 2) {
			Parameters.snpMinCover = new Integer(args[1]).intValue();
		} 
		if (args.length == 3) {
			if ((new Integer(args[2]).intValue()) == 2) {
				Parameters.snpPerW = Parameters.snpPer = (float) 0.3;
			}
		}
		Parameters.snpMinWeight = (float) 0.5 * Parameters.snpMinCover;
		Parameters.read(args[0]);
		int ux;
		int[] refSeqSize = new int[Parameters.SEQ_VAR.length];

		files       = new String[Parameters.SEQ_VAR.length];
		resultCount = new int[2][Parameters.SEQ_VAR.length];
		for(int i = 0; i < Parameters.SEQ_VAR.length; i++) {
			files[i] = Parameters.ch_name1 + Parameters.SEQ_VAR[i] + Parameters.ch_name2;
			resultCount[0][i] = resultCount[1][i] = 0;
		}
		Oligo.numberOfBACs = Parameters.SEQ_VAR.length;
		Oligo.BACs = Parameters.SEQ_VAR;
		ReferenceSequences.display = false;
		rs = new ReferenceSequences();
		rs.fillCode();
		
		ux = 0;
		ReferenceSequences.ux = ux;
		
		getRefSeqSize(Parameters.pathDB + Parameters.DATABASE, refSeqSize);
		System.err.print("time getRefSeqSize:");		
		Parameters.printTime(Parameters.numberOfTimePoints - 2);
		System.err.println();
		for(int i = 0; i < Parameters.SEQ_VAR.length; i++) {
			resultCount[0][i] = resultCount[1][i] = 0;
		}

		if(!(new File(Parameters.pathOut + "ScoreResults")).mkdir()) {
			System.err.println("Error creating the directory " + Parameters.pathOut + "ScoreResults");
		}
		//*/
		for(int i = 0; i < files.length; i++) {
			ux = 0;
			ReferenceSequences.ux = ux;
			
			rs.createMap(Parameters.pathRefSeq + files[i], files[i], i);
			System.err.print("createMap " + files[i] + ":");		
			Parameters.printTime(Parameters.numberOfTimePoints - 2);
			System.err.println("\n");

			rs.generateCoverage(Parameters.pathOut, Parameters.outFile, Parameters.pathRefSeq, files[i], ux); 
			System.err.print("generateScore(0) " + files[i] + ":");		
			Parameters.printTime(Parameters.numberOfTimePoints - 2);
			System.err.println("\n");
			
			rs.findSNPs(Parameters.pathOut, files[i]);
			System.err.print("findSNPs " + files[i] + ":");		
			Parameters.printTime(Parameters.numberOfTimePoints - 2);
			System.err.println("\n");
			///
			
		}
//*/
		System.err.print("\nTotal Execution time is: ");
		Parameters.printTime(Parameters.numberOfTimePoints - 1);
		System.err.println();
	}	
	
	static void getRefSeqSize(String dbfile, int[] refSeqSize) throws Exception {
		String line;
		StringTokenizer tokens;
		rs.refSeqSize = new int[refSeqSize.length];
		System.err.println(dbfile + "refSeqSizes");
		BufferedReader reader = new BufferedReader(new FileReader(dbfile + "refSeqSizes"));
		for (int i = 0; i < refSeqSize.length; i++) {
			System.err.print(i + "\tSize:\t");
			line           = reader.readLine();
			tokens         = new StringTokenizer(line);	
			rs.refSeqSize[i] = refSeqSize[i]      = new Integer(tokens.nextToken());
			System.err.println(refSeqSize[i]);
		}
	}
}
